version: '3.6'

configs:
  nginx_entrypoint:
    file: ./nginx/entrypoint
  nginx_template:
    file: ./nginx/default.conf.template

volumes:
  files:
    driver_opts:
      type: "nfs"
      o: "addr={{ environments[env].nfs.server_address | mandatory }},{{ environments[env].nfs.mount_opts | default(nfs_options) }}"
      device: ":{{ environments[env].nfs.app_mountpoint | mandatory }}/{{ service_name | mandatory }}-{{ env }}/app"
  ssl:
    driver_opts:
      type: "nfs"
      o: "addr={{ environments[env].nfs.server_address | mandatory }},{{ environments[env].nfs.mount_opts | default(nfs_options) }}"
      device: ":{{ environments[env].nfs.app_mountpoint | mandatory }}/{{ service_name | mandatory }}-{{ env }}/certs"

services:
  nginx:
    image: nginx:1.13.0-alpine
    command: ["nginx", "-g", "daemon off;"]
    entrypoint: ["/usr/local/bin/entrypoint"]
    configs:
      - source: nginx_entrypoint
        target: /usr/local/bin/entrypoint
        mode: 0755
      - source: nginx_template
        target: /etc/nginx/default.conf.template
    deploy:
      labels:
        - "traefik.enable=true"
        - "traefik.http.services.{{ service_name | mandatory }}-{{ env }}.loadbalancer.server.port=443"
        - "traefik.http.services.{{ service_name | mandatory }}-{{ env }}.loadbalancer.server.scheme=https"
        - "traefik.http.routers.{{ service_name | mandatory }}-{{ env }}.service={{ service_name | mandatory }}-{{ env }}"
        - "traefik.http.routers.{{ service_name | mandatory }}-{{ env }}.rule=host(`{{ environments[env].service_hostname | mandatory }}`)"
        - "traefik.http.routers.{{ service_name | mandatory }}-{{ env }}.entrypoints=https"
        - "traefik.http.routers.{{ service_name | mandatory }}-{{ env }}.tls.certresolver=le"
        - "traefik.http.routers.{{ service_name | mandatory }}-{{ env }}.tls=true"
      replicas: {{ environments[env].replicas }}
      update_config:
        parallelism: {{ environments[env].update_config.parallelism | default('1') }}
        delay: {{ environments[env].update_config.delay | default('10s') }}
      restart_policy:
        condition: on-failure
{% if enable_resources is defined and enable_resources == True %}
      resources:
        limits:
          memory: {{ environments[env].resources.limits.memory | default('128m') }}
        reservations:
          memory: {{ environments[env].resources.reservations.memory | default('64m') }}
{% endif %}

      placement:
        constraints:
          - node.role == worker
    environment:
      - SERVER_NAME={{ environments[env].service_hostname | mandatory }}
    volumes:
      - type: volume
        source: files
        target: /app
      - type: volume
        source: ssl
        target: /etc/ssl
    networks:
      - traefik_proxy

networks:
  traefik_proxy:
    external:
      name: traefik_proxy
